/****************************************************************************************/
/*											*/
/* This program is free software; you can redistribute it and/or modify it under the	*/
/* terms of the GNU General Public License as published by the Free Software		*/
/* Foundation; either version 2 of the License, or (at your option) any later version.	*/
/*											*/
/* This program is distributed in the hope that it will be useful, but WITHOUT ANY	*/
/* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A	*/
/* PARTICULAR PURPOSE. See the GNU General Public License for more details.		*/
/*											*/
/* You should have received a copy of the GNU General Public License along with this	*/
/* program; (See "LICENSE.GPL"). If not, write to the Free Software Foundation, Inc.,	*/
/* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.				*/
/*											*/
/*--------------------------------------------------------------------------------------*/
/*											*/
/*		Joerg Anders, TU Chemnitz, Fakultaet fuer Informatik, GERMANY		*/
/*		ja@informatik.tu-chemnitz.de						*/
/*											*/
/*											*/
/****************************************************************************************/

#ifndef PMXEXPORT_H

#define PMXEXPORT_H

#include <fstream>
#include <strstream.h>
#include <qlist.h>
#include <qstring.h>

class NVoice;
class NStaff;
class NKeySig;
class NNote;
class NClef;
class NChord;
class NTimeSig;
class NKeySig_;
class exportFrm;
class badmeasure;
class exportFrm;
class NMusElement;
class NMainFrameWidget;

class specialCharInfo {
	public:
		specialCharInfo(QString *info, int pos) {
			specInfo = new QString(*info);
			xpos = pos;
		}
		~specialCharInfo() {
			delete specInfo;
		}
		QString *specInfo;
		int xpos;
};

class NPmxExport {
	public:
		void exportStaffs(QString fname, QList<NStaff> *stafflist, exportFrm *frmWin, NMainFrameWidget *mainWidget);
		void doExport();
	private:
		QList<badmeasure> badlist_;
		QString lyrics2TeX(QString *lyrics);
		ofstream out_;
		ostrstream *pmxout_;
		int countof128th_;
		exportFrm *exportDialog_;
		int staffsToExport_;
		QString fileName;
		QList<NStaff> *staffList_;
		void inspectTrilpet(NMusElement *elem, int staff_nr, int barnr_);
		bool writeTrack(NVoice *voice, int staff_nr, int voice_nr,
				int voice_count, int measpsystem, bool first, const char *endOfLine, int *barpos);
		void handleSpecialChar(int elempos, QString *specialChar, int voice_count, bool force_output);
		void checkSpecialChar(int newxpos);
		int computePMXLength(int length);
		void pitchOut(NKeySig *ksig, const NNote *note, int length, NClef *ac_clef, NChord *chord, int staff_nr, int barnr);
		void setTie(NNote *note, int staff_nr, int barnr);
		void setSlur(NChord *chord, int staff_nr, int barnr);
		bool testContextChange(int voice_nr, NVoice *voice, bool first);
		void lineOut(ostrstream *outstream);
		int barNr_;
		int tipletBase_;
		NTimeSig *pendingTimeSig_;
		int posOfpendingTimeSig_;
		NKeySig *pendingKeySig_;
		int posOfpendingKeySig_;
		int pendingSpecialEnd_;
		int posOfpendingSpecialEnd_;
		int lastTone_, lastLength_;
		int openSpecialEnding_;
		bool pendingEndSpecialEnd_;
		bool drum_problem_written_;
		unsigned int tiePool_, slurPool_;
		QString LastPMXfile_;
		QList<specialCharInfo> specialCharList_;
		NMainFrameWidget *mainWidget_;
};

#endif //
