/****************************************************************************************/
/*											*/
/* This program is free software; you can redistribute it and/or modify it under the	*/
/* terms of the GNU General Public License as published by the Free Software		*/
/* Foundation; either version 2 of the License, or (at your option) any later version.	*/
/*											*/
/* This program is distributed in the hope that it will be useful, but WITHOUT ANY	*/
/* WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A	*/
/* PARTICULAR PURPOSE. See the GNU General Public License for more details.		*/
/*											*/
/* You should have received a copy of the GNU General Public License along with this	*/
/* program; (See "LICENSE.GPL"). If not, write to the Free Software Foundation, Inc.,	*/
/* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.				*/
/*											*/
/*--------------------------------------------------------------------------------------*/
/*											*/
/*		Joerg Anders, TU Chemnitz, Fakultaet fuer Informatik, GERMANY		*/
/*		ja@informatik.tu-chemnitz.de						*/
/*											*/
/*											*/
/****************************************************************************************/

#ifndef REST_H

#define REST_H

#include "muselement.h"

class QPixmap;

class NRest : public NMusElement {
	public:
		NRest(main_props_str *main_props_, staff_props_str *staff_props, int *y_voice_offs, int length=32, unsigned int status = 0);
		virtual NRest *clone();
		int getMultiRestLength() {return multiRestLength_;}
		virtual void changeLength(int length);
		virtual void draw(int flags = 0);
		virtual int getSubType() const {return length_;}
		virtual int getType() const {return T_REST;}
		virtual void setDotted(int dotcount);
		virtual int getMidiLength() const  {return midiLength_;}
		virtual void calculateDimensionsAndPixmaps();
		virtual QPoint *getTopY();
		virtual int getTopY2();
		virtual int getTopX2();
		virtual double getBotY();
		virtual void setTripletParams(QList<NMusElement> *tripletList, bool last, double m,
						 double n , double tritexn, int xstart, int xend);
		void setVoiceOffs(int *voice_offs) {yRestOffs_ = voice_offs;}
	private:
		virtual int computeMidiLength() const;
		int length_;
		int multiRestLength_;
		QPixmap *redPixmap_;
		QPixmap *blackPixmap_;
		QPixmap *greyPixmap_;
		QPoint nbaseDrawPoint_;
		QString lenString_;
		QRect pointPos1_;
		QRect pointPos2_;
		double m_, n_;
		int *yRestOffs_;
		QPoint triplet0_, triplet1_;
		QPoint triplet00_, triplet01_;
		QPoint tripletThree_;
};

#endif // REST_H
